const { refObject, Button, ImageButton, TextBox, Vector, world } = require('@tabletop-playground/api');
//-----------------------------------------------------------------
const zPosition = 0.1;

let infoName = [
  "name",
  "age",
  "gender",
  "race",
  "fraction",
  "proffesion",
  "rank"
]
let allInfo = [];
for (let i = 0; i < infoName.length; i++) {
  allInfo[infoName[i]] = new TextBox().setText("...");
  allInfo[infoName[i]].setFontSize(22);
  allInfo[infoName[i]].onTextChanged.add(() => {
    saveState();
  })
}

function CreateInfoTextBox(parent, charName, position) {
  let textUI = new UIElement();
  textUI.useWidgetSize = false;
  textUI.width = 200;
  textUI.height = 35;
  textUI.position = position;
  textUI.rotation = new Rotator(0, 0, 180);
  textUI.widget = allInfo[charName];
  textUI.scale = 0.2;
  parent.attachUI(textUI);
}
//-----------------
let characteristicsName = [
  "strenght",
  "perception",
  "endurance",
  "charism",
  "intelligence",
  "dextery",
  "luck"
];
let majorCharacteristics = [];
let bafCharacteristics = [];
let debaffCharacteristics = [];
let mainCharacteristics = [];
for (let i = 0; i < characteristicsName.length; i++) {
  majorCharacteristics[characteristicsName[i]] = new TextBox().setText("5").setEnabled(false);
  majorCharacteristics[characteristicsName[i]].setFontSize(22);
  majorCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    if (characteristicsName[i] == "intelligence") {
      let current = parseInt(majorCharacteristics[characteristicsName[i]].getText());
      characteristics.GrowthRate = current;
    }
    saveState();
  })
  //--
  bafCharacteristics[characteristicsName[i]] = new TextBox().setText("0").setInputType(4);
  bafCharacteristics[characteristicsName[i]].setFontSize(14);
  bafCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    RecalculationMajorCharacteristic(characteristicsName[i]);
  })
  //--
  debaffCharacteristics[characteristicsName[i]] = new TextBox().setText("0").setInputType(4);
  debaffCharacteristics[characteristicsName[i]].setFontSize(14);
  debaffCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    RecalculationMajorCharacteristic(characteristicsName[i]);
  })
  //--
  mainCharacteristics[characteristicsName[i]] = new TextBox().setText("5").setInputType(4);
  mainCharacteristics[characteristicsName[i]].setFontSize(14);
  mainCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    RecalculationMajorCharacteristic(characteristicsName[i]);
    characteristics.RecalculationFreePoints();
  })
}

function RecalculationMajorCharacteristic(type) {
  let main = parseInt(mainCharacteristics[type].getText());
  let debaff = parseInt(debaffCharacteristics[type].getText());
  let baff = parseInt(bafCharacteristics[type].getText());
  majorCharacteristics[type].setText(main + baff - debaff);
}

function CreateCharacteristicTextBox(parent, obj, charName, position, typeChar) {
  let textUI = new UIElement();
  textUI.position = position;
  textUI.rotation = new Rotator(0, 0, 180);
  textUI.scale = 0.2;

  if (obj) {
    let offsetButton = 0.42;
    let imageSize = 25;

    obj.decrement = new ImageButton().setImage("minus.png");
    obj.decrement.setImageSize(imageSize);
    obj.decrement.onClicked.add(() => {
      let currentValue = typeChar[charName].getText();
      if (currentValue > 0) {
        typeChar[charName].setText(currentValue - 1);
      }
    })

    let decUI = new UIElement();
    decUI.position = position.add(new Vector(0, offsetButton, 0.01));
    decUI.widget = obj.decrement;
    decUI.scale = 0.1;
    parent.attachUI(decUI);
    //--
    textUI.widget = typeChar[charName];
    //--
    obj.increment = new ImageButton().setImage("plus.png");
    obj.increment.setImageSize(imageSize);
    obj.increment.onClicked.add(() => {
      let currentValue = parseInt(typeChar[charName].getText());
      typeChar[charName].setText(currentValue + 1);
    })

    let incUI = new UIElement();
    incUI.position = position.add(new Vector(0, -offsetButton, 0.01));
    incUI.widget = obj.increment;
    incUI.scale = 0.1;
    parent.attachUI(incUI);
  } else {
    textUI.widget = typeChar[charName];
  }
  parent.attachUI(textUI);
}
//-----------------------------------------------------------------
class Info {
  constructor(parent, position) {
    this.parent = parent;
    //-------------------------
    for (let i = 0; i < infoName.length; i++) {
      CreateInfoTextBox(parent, infoName[i], position.add(new Vector(-3.26 + 0.79 * i, 2.7, 0)));
    }
    //-------------------------
    this.karmaText = new TextBox().setInputType(3).setText("0");
    this.karmaText.setFontSize(22);
    this.karmaText.onTextChanged.add(() => {
      saveState();
    })

    let textUI = new UIElement();
    textUI.position = position.add(new Vector(3.9, 0, 0));
    textUI.rotation = new Rotator(0, 0, 180);
    textUI.widget = this.karmaText;
    textUI.scale = 0.2;
    parent.attachUI(textUI);
  }

  get Karma() { return this.karmaText.getText(); }
  set Karma(value) { this.karmaText.setText(value); }
}
let info = new Info(refObject, new Vector(0, 0, zPosition));

class Characteristics {
  constructor(parent, position) {
    this.parent = parent;
    this.maxPointsVal = 40;
    //-------------------------
    this.borderDebaff = new Border();
    this.borderDebaff.setColor(new Color(1, 0, 0.05));

    let borderUI = new UIElement();
    borderUI.position = position.add(new Vector(-3.8, -6, 0));
    borderUI.widget = this.borderDebaff;
    parent.attachUI(borderUI);
    //-------------------------
    this.borderBaff = new Border();
    this.borderBaff.setColor(new Color(0.05, 0, 1));

    borderUI.position = position.add(new Vector(-3.8, -4.75, 0));
    borderUI.widget = this.borderBaff;
    parent.attachUI(borderUI);
    //-------------------------
    this.borderMain = new Border();
    this.borderMain.setColor(new Color(0.05, 1, 0.05));

    borderUI.position = position.add(new Vector(-3.8, -7.25, 0));
    borderUI.widget = this.borderMain;
    parent.attachUI(borderUI);
    //-------------------------
    for (let i = 0; i < characteristicsName.length; i++) {
      CreateCharacteristicTextBox(parent, null, characteristicsName[i], position.add(new Vector(-3.26 + 0.79 * i, -3.7, 0)), majorCharacteristics);
      CreateCharacteristicTextBox(parent, this, characteristicsName[i], position.add(new Vector(-3.26 + 0.79 * i, -4.75, 0)), bafCharacteristics);
      CreateCharacteristicTextBox(parent, this, characteristicsName[i], position.add(new Vector(-3.26 + 0.79 * i, -6, 0)), debaffCharacteristics);
      CreateCharacteristicTextBox(parent, this, characteristicsName[i], position.add(new Vector(-3.26 + 0.79 * i, -7.25, 0)), mainCharacteristics);
    }
    //-------------------------
    this.growthRate = new TextBox().setText("15").setEnabled(false);
    this.growthRate.setFontSize(22);

    let growthRateUI = new UIElement();
    growthRateUI.position = position.add(new Vector(2.8, 3.2, 0));
    growthRateUI.rotation = new Rotator(0, 0, 180);
    growthRateUI.widget = this.growthRate;
    growthRateUI.scale = 0.2;
    parent.attachUI(growthRateUI);
    //-------------------------
    this.freePoints = new TextBox().setText("5").setEnabled(false);
    this.freePoints.setFontSize(22);

    let pointsUI = new UIElement();
    pointsUI.position = position.add(new Vector(2.8, -6.5, 0.01));
    pointsUI.rotation = new Rotator(0, 0, 180);
    pointsUI.widget = this.freePoints;
    pointsUI.scale = 0.2;
    parent.attachUI(pointsUI);
    //-------------------------
    this.maxPoints = new TextBox().setText("/" + this.maxPointsVal).setEnabled(false);
    this.maxPoints.setFontSize(22);

    pointsUI.position = position.add(new Vector(2.8, -7.2, 0));
    pointsUI.widget = this.maxPoints;
    parent.attachUI(pointsUI);
  }

  RecalculationFreePoints() {
    let currentPoints = 0;
    for (let i = 0; i < characteristicsName.length; i++) {
      currentPoints += parseInt(mainCharacteristics[characteristicsName[i]].getText());
    }
    this.freePoints.setText(this.maxPointsVal - currentPoints);
  }

  get FreePoints() { return parseInt(this.freePoints.getText()); }

  get GrowthRate() { return parseInt(this.growthRate.getText()); }
  set GrowthRate(value) {
    this.growthRate.setText(value * 2 + 5);
  }
}
let characteristics = new Characteristics(refObject, new Vector(0, 0, zPosition));
//-----------------------------------------------------------------
function saveState() {
  let state = { };

  for (let i = 0; i < infoName.length; i++) {
    let index = infoName[i];
    state[index] = allInfo[index].getText();
  }
  state["karma"] = info.Karma;
  for (let i = 0; i < characteristicsName.length; i++) {
    let index = characteristicsName[i];
    state[index + "Major"] = majorCharacteristics[index].getText();
    state[index + "Baff"] = bafCharacteristics[index].getText();
    state[index + "Debaff"] = debaffCharacteristics[index].getText();
    state[index + "Main"] = mainCharacteristics[index].getText();
  }

  refObject.setSavedData(JSON.stringify(state));
}

function loadState() {
  if (refObject.getSavedData() === "") {
    saveState();
    return;
  }

  let state = JSON.parse(refObject.getSavedData());
  for (let i = 0; i < infoName.length; i++) {
    allInfo[infoName[i]].setText(state[infoName[i]] || "...");
  }
  info.Karma = state["karma"] || "0";
  for (let i = 0; i < characteristicsName.length; i++) {
    let index = characteristicsName[i];
    majorCharacteristics[index].setText(state[index + "Major"] || "5");
    bafCharacteristics[index].setText(state[index + "Baff"] || "0");
    debaffCharacteristics[index].setText(state[index + "Debaff"] || "0");
    mainCharacteristics[index].setText(state[index + "Main"] || "5");
  }
}

refObject.ResetValue = function () {
  for (let i = 0; i < infoName.length; i++) {
    allInfo[infoName[i]].setText("...");
  }
  info.Karma = "0";
  for (let i = 0; i < characteristicsName.length; i++) {
    let index = characteristicsName[i];
    majorCharacteristics[index].setText("5");
    bafCharacteristics[index].setText("0");
    debaffCharacteristics[index].setText("0");
    mainCharacteristics[index].getText("5");
  }
}
//-----------------------------------------------------------------
loadState();