const { refObject, Button, ImageButton, TextBox, Vector, world } = require('@tabletop-playground/api');
const { SetValueChars } = require('./node_modules/General_Functions.js');

refObject.onCreated.add(() => {
  refObject.setState(0);
  loadState();
})

refObject.onStateChanged.add((obj, newState, oldState) => {
  if (newState == 1) {
    characteristics.HideUI();
    info.HideUI();
    reputation.ShowUI();
  } else if (newState == 0) {
    characteristics.ShowUI();
    info.ShowUI();
    reputation.HideUI();
  }
})
//-----------------------------------------------------------------
const zPosition = 0.05;

let infoName = [
  "name",
  "age",
  "gender",
  "race",
  "fraction",
  "proffesion",
  "rank"
]
let allInfo = [];
for (let i = 0; i < infoName.length; i++) {
  allInfo[infoName[i]] = new TextBox().setText("...");
  allInfo[infoName[i]].setFontSize(44);
  allInfo[infoName[i]].onTextChanged.add(() => {
    saveState();
  })
}
//-----------------
let countReputation = 26;
let allReputation = [];
for (let i = 0; i < countReputation; i++) {
  allReputation[i] = new TextBox().setText("0");
  allReputation[i].setFontSize(34);
  allReputation[i].onTextChanged.add(() => {
    saveState();
  })
}
//-----------------
let characteristicsName = [
  "strenght",
  "perception",
  "endurance",
  "charism",
  "intelligence",
  "dextery",
  "luck"
];
let majorCharacteristics = [];
let bafCharacteristics = [];
let debaffCharacteristics = [];
let mainCharacteristics = [];
for (let i = 0; i < characteristicsName.length; i++) {
  majorCharacteristics[characteristicsName[i]] = new TextBox().setText("5").setEnabled(false);
  majorCharacteristics[characteristicsName[i]].setFontSize(40);
  majorCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    let value = parseInt(majorCharacteristics[characteristicsName[i]].getText());
    if (characteristicsName[i] == "intelligence") {
      let current = value;
      characteristics.GrowthRate = current;
    }
    SetValueChars(value, characteristicsName[i]);
    saveState();
  })
  //--
  bafCharacteristics[characteristicsName[i]] = new TextBox().setText("0").setInputType(4);
  bafCharacteristics[characteristicsName[i]].setFontSize(20);
  bafCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    RecalculationMajorCharacteristic(characteristicsName[i]);
  })
  //--
  debaffCharacteristics[characteristicsName[i]] = new TextBox().setText("0").setInputType(4);
  debaffCharacteristics[characteristicsName[i]].setFontSize(20);
  debaffCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    RecalculationMajorCharacteristic(characteristicsName[i]);
  })
  //--
  mainCharacteristics[characteristicsName[i]] = new TextBox().setText("5").setInputType(4);
  mainCharacteristics[characteristicsName[i]].setFontSize(20);
  mainCharacteristics[characteristicsName[i]].onTextChanged.add(() => {
    RecalculationMajorCharacteristic(characteristicsName[i]);
    characteristics.RecalculationFreePoints();
  })
}

function RecalculationMajorCharacteristic(type) {
  let main = parseInt(mainCharacteristics[type].getText());
  let debaff = parseInt(debaffCharacteristics[type].getText());
  let baff = parseInt(bafCharacteristics[type].getText());
  majorCharacteristics[type].setText(main + baff - debaff);
}

function CreateCharacteristicTextBox(parent, charName, position, typeChar) {
  let imageSize = 25;
  let offsetY = 20;
  let buttonOffsetY = offsetY + 5;

  let decrement = new ImageButton().setImage("minus.png");
  decrement.setImageSize(imageSize);
  decrement.onClicked.add(() => {
    let currentValue = typeChar[charName].getText();
    if (currentValue > 0) {
      typeChar[charName].setText(currentValue - 1);
    }
  })
  parent.addChild(decrement, position.x - 40, position.y + buttonOffsetY, 30, 30);
  //--
  parent.addChild(typeChar[charName], position.x, position.y + offsetY, 40, 40);
  //--
  let increment = new ImageButton().setImage("plus.png");
  increment.setImageSize(imageSize);
  increment.onClicked.add(() => {
    let currentValue = parseInt(typeChar[charName].getText());
    typeChar[charName].setText(currentValue + 1);
  })
  parent.addChild(increment, position.x + 50, position.y + buttonOffsetY, 30, 30);
}
//-----------------------------------------------------------------
class Info {
  constructor(parent, position) {
    this.parent = parent;
    this.showPosition = position;
    this.hidePosition = position.add(new Vector(0, 0, -zPosition));
    //-------------------------
    this.nC = new Canvas();

    this.nCUI = new UIElement();
    this.nCUI.useWidgetSize = false;
    this.nCUI.position = position;
    this.nCUI.widget = this.nC;
    this.nCUI.width = 1600;
    this.nCUI.height = 1000;
    this.nCUI.scale = 0.1;
    parent.attachUI(this.nCUI);
    //-------------------------
    for (let i = 0; i < infoName.length; i++) {
      this.nC.addChild(allInfo[infoName[i]], 330, 135 + i * 78, 400, 75);
    }
    //-------------------------
    this.karmaText = new TextBox().setInputType(3).setText("0");
    this.karmaText.setFontSize(44);
    this.karmaText.onTextChanged.add(() => {
      saveState();
    })
    this.nC.addChild(this.karmaText, 725, 850, 160, 75);
  }

  get Karma() { return this.karmaText.getText(); }
  set Karma(value) { this.karmaText.setText(value); }

  HideUI() {
    this.nCUI.position = this.hidePosition;
    this.parent.updateUI(this.nCUI);
  }
  ShowUI() {
    this.nCUI.position = this.showPosition;
    this.parent.updateUI(this.nCUI);
  }
}
let info = new Info(refObject, new Vector(0, 0, zPosition));

class Characteristics {
  constructor(parent, position) {
    this.parent = parent;
    this.maxPointsVal = 40;
    this.showPosition = position;
    this.hidePosition = position.add(new Vector(0, 0, -zPosition));
    //-------------------------
    this.nC = new Canvas();

    this.nCUI = new UIElement();
    this.nCUI.useWidgetSize = false;
    this.nCUI.position = position;
    this.nCUI.widget = this.nC;
    this.nCUI.width = 1600;
    this.nCUI.height = 1000;
    this.nCUI.scale = 0.1;
    parent.attachUI(this.nCUI);
    //-------------------------
    let borderBaff = new Border();
    borderBaff.setColor(new Color(0.05, 0, 1));
    this.nC.addChild(borderBaff, 1250, 100, 40, 40);
    //-------------------------
    let borderDebaff = new Border();
    borderDebaff.setColor(new Color(1, 0, 0.05));
    this.nC.addChild(borderDebaff, 1380, 100, 40, 40);
    //-------------------------
    let borderMain = new Border();
    borderMain.setColor(new Color(0.05, 1, 0.05));
    this.nC.addChild(borderMain, 1510, 100, 40, 40);
    //-------------------------
    for (let i = 0; i < characteristicsName.length; i++) {
      this.nC.addChild(majorCharacteristics[characteristicsName[i]], 1135, 145 + i * 78, 70, 65);
      CreateCharacteristicTextBox(this.nC, characteristicsName[i], position.add(new Vector(1250, 140 + i * 78, 0)), bafCharacteristics);
      CreateCharacteristicTextBox(this.nC, characteristicsName[i], position.add(new Vector(1380, 140 + i * 78, 0)), debaffCharacteristics);
      CreateCharacteristicTextBox(this.nC, characteristicsName[i], position.add(new Vector(1510, 140 + i * 78, 0)), mainCharacteristics);
    }
    //-------------------------
    this.growthRate = new TextBox().setText("15").setEnabled(false);
    this.growthRate.setFontSize(44);
    this.nC.addChild(this.growthRate, 420, 735, 85, 85);
    //-------------------------
    this.freePoints = new TextBox().setText("5").setEnabled(false);
    this.freePoints.setFontSize(44);
    this.nC.addChild(this.freePoints, 1315, 735, 85, 85);
    //-------------------------
    this.maxPoints = new TextBox().setText("/" + this.maxPointsVal).setEnabled(false);
    this.maxPoints.setFontSize(44);
    this.nC.addChild(this.maxPoints, 1400, 735, 105, 85);
  }

  RecalculationFreePoints() {
    let currentPoints = 0;
    for (let i = 0; i < characteristicsName.length; i++) {
      currentPoints += parseInt(mainCharacteristics[characteristicsName[i]].getText());
    }
    this.freePoints.setText(this.maxPointsVal - currentPoints);
  }

  get FreePoints() { return parseInt(this.freePoints.getText()); }

  get GrowthRate() { return parseInt(this.growthRate.getText()); }
  set GrowthRate(value) {
    this.growthRate.setText(value * 2 + 5);
  }

  HideUI() {
    this.nCUI.position = this.hidePosition;
    this.parent.updateUI(this.nCUI);
  }
  ShowUI() {
    this.nCUI.position = this.showPosition;
    this.parent.updateUI(this.nCUI);
  }
}
let characteristics = new Characteristics(refObject, new Vector(0, 0, zPosition));

class Reputation {
  constructor(parent, position) {
    this.parent = parent;
    this.showPosition = position.add(new Vector(0, 0, zPosition));
    this.hidePosition = position;
    //-------------------------
    this.nC = new Canvas();

    this.nCUI = new UIElement();
    this.nCUI.useWidgetSize = false;
    this.nCUI.position = position;
    this.nCUI.widget = this.nC;
    this.nCUI.width = 1600;
    this.nCUI.height = 1000;
    this.nCUI.scale = 0.1;
    parent.attachUI(this.nCUI);
    //-------------------------
    let offsetY = 0; let offsetX = 430;
    for (let i = 0; i < countReputation; i++, offsetY++) {
      this.nC.addChild(allReputation[i], offsetX, 95 + offsetY * 65, 400, 60);
      if (i == 12) { offsetY = -1; offsetX = 1180; }
    }
  }

  HideUI() {
    this.nCUI.position = this.hidePosition;
    this.parent.updateUI(this.nCUI);
  }
  ShowUI() {
    this.nCUI.position = this.showPosition;
    this.parent.updateUI(this.nCUI);
  }
}
let reputation = new Reputation(refObject, new Vector(0, 0, 0));
//-----------------------------------------------------------------
function saveState() {
  let state = {};

  for (let i = 0; i < infoName.length; i++) {
    let index = infoName[i];
    state[index] = allInfo[index].getText();
  }
  state["karma"] = info.Karma;
  for (let i = 0; i < characteristicsName.length; i++) {
    let index = characteristicsName[i];
    state[index + "Major"] = majorCharacteristics[index].getText();
    state[index + "Baff"] = bafCharacteristics[index].getText();
    state[index + "Debaff"] = debaffCharacteristics[index].getText();
    state[index + "Main"] = mainCharacteristics[index].getText();
  }
  for (let i = 0; i < countReputation; i++) {
    state[i] = allReputation[i].getText();
  }

  refObject.setSavedData(JSON.stringify(state));
}

function loadState() {
  if (refObject.getSavedData() === "") {
    saveState();
    return;
  }

  let state = JSON.parse(refObject.getSavedData());
  for (let i = 0; i < infoName.length; i++) {
    allInfo[infoName[i]].setText(state[infoName[i]] || "...");
  }
  info.Karma = state["karma"] || "0";
  for (let i = 0; i < characteristicsName.length; i++) {
    let index = characteristicsName[i];
    majorCharacteristics[index].setText(state[index + "Major"] || "5");
    bafCharacteristics[index].setText(state[index + "Baff"] || "0");
    debaffCharacteristics[index].setText(state[index + "Debaff"] || "0");
    mainCharacteristics[index].setText(state[index + "Main"] || "5");
  }
  for (let i = 0; i < countReputation; i++) {
    allReputation[i].setText(state[i] || "0");
  }
}

refObject.ResetValue = function () {
  for (let i = 0; i < infoName.length; i++) {
    allInfo[infoName[i]].setText("...");
  }
  info.Karma = "0";
  for (let i = 0; i < characteristicsName.length; i++) {
    let index = characteristicsName[i];
    majorCharacteristics[index].setText("5");
    bafCharacteristics[index].setText("0");
    debaffCharacteristics[index].setText("0");
    mainCharacteristics[index].setText("5");
  }
}