const { Vector, world } = require('@tabletop-playground/api');

let changerObjects = []
let characteristic = []
let characteristicsName = [
  "strenght",
  "perception",
  "endurance",
  "charism",
  "intelligence",
  "dextery",
  "luck"
];
for (let i = 0; i < characteristicsName.length; i++) {
  characteristic[i] = 5;
}
function GetValueChars(type) {
  return characteristic[type];
}
function SetValueChars(value, type) {
  characteristic[type] = value;
  for (let i = 0; i < changerObjects.length; i++) {
    world.getObjectById(changerObjects[i]).RecalculationMainCharacteristic(type, characteristic[type]);
  }
}
function SetIdObjec(id) {
  changerObjects.push(id);
}

const TypeShow = {
  STANDART: 0,
  PROCENT: 1,
}

function PositionsFontUI(startX, i) { return startX - 0.005 * i; }

function ChangeImageSlider(image, value, maxValue, position, text, parent, startX, type, multiply) {
  type = type || TypeShow.STANDART;
  multiply = multiply || 10;
  let procent = (100 * value) / maxValue;
  image.width = procent * multiply;
  image.position = position.add(new Vector(0, PositionsFontUI(startX, image.width), 0));
  if (TypeShow.STANDART == type)
    text.setText(value + "/" + maxValue);
  else if (TypeShow.PROCENT == type)
    text.setText(procent + "%");
  parent.updateUI(image);
}

module.exports.ChangeImageSlider = ChangeImageSlider;
module.exports.PositionsFontUI = PositionsFontUI;
module.exports.TypeShow = TypeShow;
module.exports.GetValueChars = GetValueChars;
module.exports.SetValueChars = SetValueChars;
module.exports.SetIdObjec = SetIdObjec;